#include <string.h>

#include "sentence.h"

/***********************************************************************************//**
 * ctor
 **************************************************************************************/
cSentence::cSentence( )
{
  m_lstSyllable = new cSyllable[100];
  m_nbMaxSyllable = 100;

  m_nbSyllable = 0;
  m_start = 0;
  m_duration = 0;
  m_posSyllable = 0;
}

/***********************************************************************************//**
 * dtor
 **************************************************************************************/
cSentence::~cSentence( )
{
  delete[]m_lstSyllable;
  m_lstSyllable = NULL;
  m_nbMaxSyllable = 0;
}

/***********************************************************************************//**
 * add one syllable
 *
 * @param [in] start :
 * @param [in] duration :
 * @param [in] note :
 * @param [in] strSyllable :
 *
 * @return : 0:ok -1:fail(memory full)
 **************************************************************************************/
int cSentence::AddSyllable( int start, int duration, int note, const char *strSyllable )
{
  int retVal=-1;

  if( m_nbSyllable < m_nbMaxSyllable )
  {
    m_duration += duration;
    m_lstSyllable[ m_nbSyllable ].Set( start, duration, note, strSyllable );
    m_nbSyllable++;

    retVal = 0;
  }
  else
  {
    retVal = -1;
  }

  return( retVal );
}

/***********************************************************************************//**
 * define the begin
 *
 * @param [in] start :
 **************************************************************************************/
int cSentence::SetStart( int Start )
{
  m_start = Start;

  return( 0 );
}

/***********************************************************************************//**
 * restart
 *
 * @return [in] start :
 **************************************************************************************/
int cSentence::SetAtBegin( void )
{
  m_posSyllable = 0;

  return( 0 );
}

/***********************************************************************************//**
 * return the syllable
 *
 * @param [out] syll :
 * @param [out] status :
 * @param [in] currentTime :
 *
 * @return :
 **************************************************************************************/
int cSentence::GetNextSyllable( cSyllable & syll, int *status, int currentTime )
{
  int retVal = 0;

  *status = 0;

  if( m_posSyllable < m_nbSyllable )
  {
    if( currentTime < m_lstSyllable[m_posSyllable].m_start )
    {
      *status = 0;
    }

    if( currentTime >= m_lstSyllable[m_posSyllable].m_start &&
        currentTime <= m_lstSyllable[m_posSyllable].m_start + m_lstSyllable[m_posSyllable].m_duration &&
        m_lstSyllable[m_posSyllable].m_duration > 0 )
    {
      *status = ( 100 * ( currentTime - m_lstSyllable[m_posSyllable].m_start ) ) / m_lstSyllable[m_posSyllable].m_duration;
    }

    if( currentTime > m_lstSyllable[m_posSyllable].m_start + m_lstSyllable[m_posSyllable].m_duration )
    {
      *status = 100;
    }

    syll = m_lstSyllable[m_posSyllable];
    m_posSyllable++;
  }
  else
  {
    retVal = 1;
  }

  return( retVal );
}
